/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CFOP                                                     */
/* Tabela : CODFISCOPER                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CFOP
BEFORE INSERT OR UPDATE OR DELETE
ON CODFISCOPER FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCFOP := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUCFOP := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CODFISCOPER', '', 'NRINCIDCFOP='||:OLD.NRINCIDCFOP||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CODFISCOPER MODIFY DTULTATUCFOP DEFAULT SYSDATE
/
